package cpcns.common.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.model.BaseEntity;
import cpcns.common.service.ICommonService;
import cpcns.common.service.IPaiXuService;
import cpcns.danganmenlei.model.GDangAnMenLei;
import cpcns.danganmenlei.service.IGDangAnMenLeiService;
import cpcns.danganzhengli.shengjijuxiangmu.model.DShenJiJuXiangMu;
import cpcns.danganzhengli.wenshu.anjuan.model.DAnJuan;
import cpcns.danganzhengli.wenshu.danganhe.model.DDangAnHe;
import cpcns.danganzhengli.wenshu.wenjian.model.DWenJian;
import cpcns.dingZhi.zHUANTI.model.zHUANTI;
import cpcns.dingZhi.zhuanYeWenJian.model.zhuanYeWenJian;
import cpcns.utils.CommStatic;
import cpcns.utils.Json;
import cpcns.utils.YeWuStatic;
import java.io.UnsupportedEncodingException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/paiXu"})
public class paiXuController extends commonController {
  @Autowired
  private IPaiXuService paiXuService;
  
  @Autowired
  private ICommonService commonService;
  
  @Autowired
  private IGDangAnMenLeiService gDangAnMenLeiService;
  
  @RequestMapping({"/loadPaiXu.do"})
  public String loadPaiXu(Model model) throws UnsupportedEncodingException {
    String xuHao = getRequest().getParameter("xuHao");
    String quanZongHao = getRequest().getParameter("quanZongHao");
    String xuHaoStr = getRequest().getParameter("xuHaoStr");
    String state = getRequest().getParameter("state");
    String menLei = getRequest().getParameter("menLei");
    String dayinleixing = getRequest().getParameter("dayinleixing");
    String xuHaoGuiZe = getRequest().getParameter("xuHaoGuiZe");
    String customField = getRequest().getParameter("customField");
    String customf = "";
    String customFieldStr = getRequest().getParameter("customFieldStr");
    StringBuilder sb = new StringBuilder();
    sb.append("<thead>");
    sb.append("<tr>");
    if (StringUtils.isNotBlank(xuHao) && StringUtils.isNotBlank(xuHaoStr))
      sb.append("<th data-options=\"field:'xuHao',align:'center',width:60,formatter:setXuHao\">" + xuHaoStr + "</th>"); 
    sb.append("<th data-options=\"field:'hangBiaoShi',align:'center',hidden:true\"></th>");
    if (!"D_DangAnHe".equals(this.table))
      sb.append("<th data-options=\"field:'biaoTi',align:'center',width:500\">题名</th>"); 
    sb.append("<th data-options=\"field:'guiDangNianDu',align:'center',width:80\">年度</th>");
    sb.append("<th data-options=\"field:'baoGuanQiXian',align:'center',width:100,formatter:getQiXian\">保管期限</th>");
    if (StringUtils.isNotBlank(customField) && StringUtils.isNotBlank(customFieldStr)) {
      String[] cfs = customField.split(",");
      String[] cfss = customFieldStr.split(",");
      for (int i = 0; i < cfs.length; i++) {
        StringBuffer temp = new StringBuffer("field:'");
        String cf = cfs[i];
        String[] info = cf.split("_");
        String cfc = cfss[i];
        if ("".equals(customf)) {
          customf = info[0];
        } else {
          customf = String.valueOf(customf) + "," + info[0];
        } 
        temp.append(info[0]).append("',align:'center',width:160");
        if (!info[2].equals("0"))
          temp.append(",sortable:true"); 
        sb.append("<th data-options=\"").append(temp).append("\">").append(cfc).append("</th>");
      } 
    } 
    sb.append("</tr>");
    sb.append("</thead>");
    System.out.println(sb.toString());
    if (menLei.equals("XWS") && StringUtils.isNotBlank(menLei)) {
      GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(menLei);
      if (dam != null && dam.getBiaoShi() != null && dam.getPaiXuGuiZe() != null) {
        String paiXuGuiZe = dam.getPaiXuGuiZe();
        getRequest().setAttribute("paiXuGuiZe", paiXuGuiZe);
      } 
    } 
    getRequest().setAttribute("html", sb.toString());
    getRequest().setAttribute("xuHao", xuHao);
    getRequest().setAttribute("xuHaoStr", xuHaoStr);
    getRequest().setAttribute("state", state);
    getRequest().setAttribute("menLei", menLei);
    getRequest().setAttribute("customField", customf);
    getRequest().setAttribute("xuHaoGuiZe", xuHaoGuiZe);
    getRequest().setAttribute("quanZongHao", quanZongHao);
    getRequest().setAttribute("dayinleixing", dayinleixing);
    return "/danganzhengli/paixu/PaiXu";
  }
  
  @RequestMapping({"/queryPaiXu.do"})
  @ResponseBody
  public void queryPaiXu(HttpServletRequest request, HttpServletResponse response) {
    String xuHao = getRequest().getParameter("xuHao");
    String customField = request.getParameter("customField");
    String paiXuGuiZe = request.getParameter("paiXuGuiZe");
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    StringBuffer sqlWhere = new StringBuffer();
    Iterator<String> iterator = jsonObject.keys();
    if (this.table.equals("D_WenJian")) {
      sqlWhere.append(" and zhuangTai  in (0,2) and guanLianBiaoShi=0");
    } else {
      sqlWhere.append(" and zhuangTai  in (0,2) ");
    } 
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && 
        !"server".equals(key) && !"table".equals(key) && !"xuHao".equals(key) && !"order".equals(key) && !"sort".equals(key) && !"customField".equals(key) && !"paiXuGuiZe".equals(key)) {
        if ("end".equals(key)) {
          sqlWhere.append(" and " + xuHao + "<=" + value);
          continue;
        } 
        if ("start".equals(key)) {
          sqlWhere.append(" and " + xuHao + ">=" + value);
          continue;
        } 
        if (!key.contains("String")) {
          sqlWhere.append(" and ").append(String.valueOf(key) + " = " + value);
          continue;
        } 
        key = key.substring(0, key.indexOf("String"));
        sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
      } 
    } 
    String px = "";
    if (this.table.equals("D_WenJian")) {
      px = CommStatic.getOrderByNew(request, String.valueOf(xuHao) + " asc", "chengWenRiQi asc", this.commonService.getDataType());
    } else {
      px = CommStatic.getOrderByNew(request, String.valueOf(xuHao) + " asc", this.commonService.getDataType());
    } 
    if (StringUtils.isNotBlank(paiXuGuiZe))
      px = px.replaceAll("fenLeiMingCheng", paiXuGuiZe); 
    sqlWhere.append(px.replaceAll("laiYuanMingCheng", "laiYuan").replaceAll("order by", "order by baoGuanQiXian desc ,"));
    String cf = String.valueOf(xuHao) + " as xuHao";
    if (StringUtils.isNotBlank(customField))
      cf = String.valueOf(cf) + " , " + customField; 
    List<Map<String, Object>> list = this.paiXuService.queryPaiXu(this.table, this.server, sqlWhere.toString(), cf);
    Map<String, Object> map = new HashMap<>();
    map.put("rows", list);
    String jsonString = JsonWithJacksonUtils.getInstance().map2Json(map).replaceAll("GUIDANGNIANDU", "guiDangNianDu")
      .replaceAll("BIAOTI", "biaoTi").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("HANGBIAOSHI", "hangBiaoShi")
      .replaceAll("XUHAO", "xuHao").replaceAll("DANGHAO", "dangHao").replaceAll("QIYEHAO", "qiYeHao").replaceAll("ZHIYEHAO", "zhiYeHao")
      .replaceAll("WENZHONG", "wenZhong").replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng");
    String[] fs = customField.split(",");
    for (int f = 0; f < fs.length; f++)
      jsonString = jsonString.replaceAll(fs[f].toUpperCase(), fs[f]); 
    responseWriter(response, jsonString);
  }
  
  @RequestMapping({"/saveSort.do"})
  public void saveSort(HttpServletRequest request, HttpServletResponse response, Model model) {
    String hbs = getRequest().getParameter("ids");
    String xh = getRequest().getParameter("xuhaos");
    String xuHao = getRequest().getParameter("xuHao");
    String server = getRequest().getParameter("server");
    String table = getRequest().getParameter("table");
    String stateStr = getRequest().getParameter("state");
    String menLei = getRequest().getParameter("menLei");
    Integer state = Integer.valueOf(0);
    if (StringUtils.isNotBlank(stateStr))
      state = Integer.valueOf(Integer.parseInt(stateStr)); 
    ResultMessage rm = new ResultMessage();
    if (StringUtils.isNotBlank(hbs) && StringUtils.isNotBlank(xh)) {
      String[] hbss = hbs.split(",");
      String[] xhs = xh.split(",");
      for (int i = 0; i < hbss.length; i++) {
        Map<String, String> map1 = new HashMap<>();
        map1.put(xuHao, xhs[i].toString());
        if ("D_DangAnHe".equals(table)) {
          DDangAnHe dah = (DDangAnHe)this.commonService.getObjectById(DDangAnHe.class, Integer.valueOf(Integer.parseInt(hbss[i])));
          dah.setXuHao(Integer.valueOf(Integer.parseInt(xhs[i])));
          String hhgz = "quanZongHao-menLei-xuHao";
          String hhfgf = "-";
          Map<String, String> map2 = new HashMap<>();
          map2.put("hangBiaoShi", hbss[i].toString());
          this.commonService.updateInfo(server, table, map1, map2);
          this.commonService.addDA_RiZhi(getCurrentUser(), getServer(), "D_DangAnHe", hbss[i].toString(), "0$." + dah.getXuHao() + "$." + dah.getMenLei(), "排序");
        } else if ("D_AnJuan".equals(table)) {
          DAnJuan aj = (DAnJuan)this.commonService.getObjectById(DAnJuan.class, Integer.valueOf(Integer.parseInt(hbss[i])));
          aj.setXuHao(Integer.valueOf(Integer.parseInt(xhs[i])));
          GDangAnMenLei dhgz = this.gDangAnMenLeiService.getByFenLeiHao(aj.getMenLei());
          String json = Json.bean2Json(aj);
          Map<String, Object> dhmap = Json.jsonStrToMap(json);
          dhmap.put("table", "D_AnJuan");
          String ajdh = "";
          if (dhgz != null) {
            ajdh = CommStatic.getDangHaoGuiZeToStr(dhmap, dhgz.getDangHaoGuiZe(), dhgz.getFenGeFu());
            map1.put("dangHaoString", ajdh);
          } 
          Map<String, Object> map = new HashMap<>();
          map.put("guanLianBiaoShi", Integer.valueOf(Integer.parseInt(hbss[i])));
          map.put("guiDangLeiXing", Integer.valueOf(Integer.parseInt(hbss[i])));
          List<DWenJian> list = this.commonService.getListHQL("DWenJian", map);
          if (list != null && list.size() > 0) {
            for (int j = 0; j < list.size(); j++) {
              DWenJian wenJian = list.get(j);
              Map<String, String> wenJianMap = new HashMap<>();
              wenJianMap.put("hangBiaoShi", wenJian.getHangBiaoShi().toString());
              String dh = String.valueOf(ajdh) + dhgz.getFenGeFu() + CommStatic.geShiHuanStr((String)wenJian.getXuHao(), 4);
              Map<String, String> wenJianMap1 = new HashMap<>();
              wenJianMap1.put("dangHaoString", dh);
              this.commonService.updateInfo(server, "D_WenJian", wenJianMap1, wenJianMap);
              this.commonService.addDA_RiZhi(getCurrentUser(), server, "D_WenJian", wenJian.getHangBiaoShi(), String.valueOf(wenJian.getBiaoTi()) + "$." + wenJian.getDangHao() + "$." + wenJian.getMenLei(), "排序");
            } 
            Map<String, String> map2 = new HashMap<>();
            map2.put("hangBiaoShi", hbss[i].toString());
            this.commonService.updateInfo(server, table, map1, map2);
            this.commonService.addDA_RiZhi(getCurrentUser(), getServer(), "D_AnJuan", aj.getHangBiaoShi(), String.valueOf(aj.getBiaoTi()) + "$." + aj.getDangHao() + "$." + aj.getMenLei(), "排序");
          } 
        } else if (table.toUpperCase().equals("D_ZHUANYEWENJIAN")) {
          zhuanYeWenJian wenJian = (zhuanYeWenJian)this.commonService.getObjectById(zhuanYeWenJian.class, Integer.valueOf(Integer.parseInt(hbss[i])));
          wenJian.setXuHao(Integer.valueOf(Integer.parseInt(xhs[i])));
          GDangAnMenLei dhgz = this.gDangAnMenLeiService.getByFenLeiHao(wenJian.getMenLei());
          String json = Json.bean2Json(wenJian);
          Map<String, Object> map = Json.jsonStrToMap(json);
          if (StringUtils.isNotBlank(wenJian.getDangHao())) {
            String old = wenJian.getDangHao().substring(0, wenJian.getDangHao().lastIndexOf(dhgz.getFenGeFu()));
            String dh = String.valueOf(old) + dhgz.getFenGeFu() + CommStatic.geShiHuanStr((new StringBuilder(String.valueOf(xhs[i]))).toString(), 4);
            map1.put("dangHaoString", dh);
            wenJian.setDangHao(dh);
          } 
          Map<String, String> map2 = new HashMap<>();
          map2.put("hangBiaoShi", hbss[i].toString());
          this.commonService.updateInfo(server, table, map1, map2);
          this.commonService.addDA_RiZhi(getCurrentUser(), server, table, wenJian.getHangBiaoShi(), String.valueOf(wenJian.getBiaoTi()) + "$." + wenJian.getDangHao() + "$." + wenJian.getMenLei(), "排序");
        } else if (table.toUpperCase().equals("D_ZHUANTI")) {
          zHUANTI wenJian = (zHUANTI)this.commonService.getObjectById(zHUANTI.class, Integer.valueOf(Integer.parseInt(hbss[i])));
          wenJian.setXuHao(Integer.valueOf(Integer.parseInt(xhs[i])));
          GDangAnMenLei dhgz = this.gDangAnMenLeiService.getByFenLeiHao(wenJian.getMenLei());
          String json = Json.bean2Json(wenJian);
          Map<String, Object> map = Json.jsonStrToMap(json);
          if (StringUtils.isNotBlank(wenJian.getDangHao())) {
            String old = wenJian.getDangHao().substring(0, wenJian.getDangHao().lastIndexOf(dhgz.getFenGeFu()));
            String dh = String.valueOf(old) + dhgz.getFenGeFu() + CommStatic.geShiHuanStr((new StringBuilder(String.valueOf(xhs[i]))).toString(), 4);
            map1.put("dangHaoString", dh);
            wenJian.setDangHao(dh);
          } 
          Map<String, String> map2 = new HashMap<>();
          map2.put("hangBiaoShi", hbss[i].toString());
          this.commonService.updateInfo(server, table, map1, map2);
          this.commonService.addDA_RiZhi(getCurrentUser(), server, table, wenJian.getHangBiaoShi(), String.valueOf(wenJian.getBiaoTi()) + "$." + wenJian.getDangHao() + "$." + wenJian.getMenLei(), "排序");
        } else if ("D_ShenJiJuXiangMu".equals(table) && "SJJXMXM".equals(menLei)) {
          DShenJiJuXiangMu aj = (DShenJiJuXiangMu)this.commonService.getObjectById(DShenJiJuXiangMu.class, Integer.valueOf(Integer.parseInt(hbss[i])));
          aj.setXuHao(Integer.valueOf(Integer.parseInt(xhs[i])));
          GDangAnMenLei dhgz = this.gDangAnMenLeiService.getByFenLeiHao(aj.getMenLei());
          String json = Json.bean2Json(aj);
          Map<String, Object> dhmap = Json.jsonStrToMap(json);
          dhmap.put("table", "ShenJiJuXiangMu");
          String ajdh = "";
          if (dhgz != null) {
            ajdh = CommStatic.getDangHaoGuiZeToStr(dhmap, dhgz.getAnJuanDangHao(), dhgz.getFenGeFu());
            map1.put("dangHaoString", ajdh);
          } 
          Map<String, Object> map = new HashMap<>();
          map.put("guanLianBiaoShi", Integer.valueOf(Integer.parseInt(hbss[i])));
          List<DWenJian> list = this.commonService.getListHQL("DWenJian", map);
          if (list != null && list.size() > 0)
            for (int j = 0; j < list.size(); j++) {
              DWenJian wenJian = list.get(j);
              Map<String, String> wenJianMap = new HashMap<>();
              wenJianMap.put("hangBiaoShi", wenJian.getHangBiaoShi().toString());
              String dh = String.valueOf(ajdh) + dhgz.getFenGeFu() + CommStatic.geShiHuanStr((String)wenJian.getXuHao(), 4);
              Map<String, String> wenJianMap1 = new HashMap<>();
              wenJianMap1.put("dangHaoString", dh);
              this.commonService.updateInfo(server, "D_WenJian", wenJianMap1, wenJianMap);
              this.commonService.addDA_RiZhi(getCurrentUser(), server, "D_WenJian", wenJian.getHangBiaoShi(), String.valueOf(wenJian.getBiaoTi()) + "$." + wenJian.getDangHao() + "$." + wenJian.getMenLei(), "排序");
            }  
          Map<String, String> map2 = new HashMap<>();
          map2.put("hangBiaoShi", hbss[i].toString());
          this.commonService.updateInfo(server, table, map1, map2);
          this.commonService.addDA_RiZhi(getCurrentUser(), getServer(), "D_ShenJiJuXiangMu", aj.getHangBiaoShi(), String.valueOf(aj.getBiaoTi()) + "$." + aj.getDangHao() + "$." + aj.getMenLei(), "排序");
        } else {
          BaseEntity wenJian = (BaseEntity)this.commonService.getObjectById(YeWuStatic.getMenLeiToEntity(menLei).getClass(), Integer.valueOf(Integer.parseInt(hbss[i])));
          wenJian.setXuHao(Integer.valueOf(Integer.parseInt(xhs[i])));
          GDangAnMenLei dhgz = this.gDangAnMenLeiService.getByFenLeiHao(wenJian.getMenLei());
          String json = Json.bean2Json(wenJian);
          Map<String, Object> map = Json.jsonStrToMap(json);
          if (StringUtils.isNotBlank(wenJian.getDangHao())) {
            String old = wenJian.getDangHao().substring(0, wenJian.getDangHao().lastIndexOf(dhgz.getFenGeFu()));
            int len = 4;
            if (menLei.equals("WS"))
              len = 3; 
            String dh = String.valueOf(old) + dhgz.getFenGeFu() + CommStatic.geShiHuanStr((new StringBuilder(String.valueOf(xhs[i]))).toString(), len);
            map1.put("dangHaoString", dh);
            wenJian.setDangHao(dh);
          } 
          Map<String, String> map2 = new HashMap<>();
          map2.put("hangBiaoShi", hbss[i].toString());
          this.commonService.updateInfo(server, table, map1, map2);
          this.commonService.addDA_RiZhi(getCurrentUser(), server, "D_WenJian", wenJian.getHangBiaoShi(), String.valueOf(wenJian.getBiaoTi()) + "$." + wenJian.getDangHao() + "$." + wenJian.getMenLei(), "排序");
        } 
        rm.setSuccess(true);
        rm.setInfo("操作成功！");
      } 
    } else {
      rm.setSuccess(false);
      rm.setInfo("操作失败！");
    } 
    rm.addResultMessage("data", "[{}]");
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/validationYouLiWenJian.do"})
  @ResponseBody
  public void validationYouLiWenJian(HttpServletRequest request, HttpServletResponse response) {
    String fenLeiMingCheng = getRequest().getParameter("fenLeiMingCheng");
    String menLei = getRequest().getParameter("menLei");
    String baoGuanQiXian = getRequest().getParameter("baoGuanQiXian");
    String guiDangNianDu = getRequest().getParameter("guiDangNianDu");
    String table = getRequest().getParameter("table");
    String xuHaoGuiZe = getRequest().getParameter("xuHaoGuiZe");
    String msg = "500";
    StringBuffer sb = new StringBuffer();
    sb.append("select guanLianBiaoShi from " + table + " where 1=1 ");
    if (StringUtils.isNotBlank(baoGuanQiXian))
      sb.append("and baoGuanQiXian='" + baoGuanQiXian + "'"); 
    if ("3".equals(xuHaoGuiZe)) {
      sb.append("and fenLeiMingCheng='" + fenLeiMingCheng + "' and guiDangNianDu= " + guiDangNianDu + " and menLei='" + menLei + "' and zhuangTai not in(3,4) and guanLianBiaoShi>0");
    } else {
      sb.append("and guiDangNianDu= " + guiDangNianDu + " and menLei='" + menLei + "' and zhuangTai not in(3,4) and guanLianBiaoShi>0");
    } 
    List pagevo = this.commonService.getList(sb.toString());
    if (pagevo.size() > 0)
      msg = "600"; 
    responseWriter(response, msg.toString());
  }
}
